using System;

namespace ReflectionIT.Data.Sql
{
	/// <summary>
	/// Base Classes for all SQL clauses
	/// </summary>
	public abstract class ClauseBase : IToken {

		private TokenList _list = new TokenList();
		private StatementBase _statement;
		private bool _empty = true;

		public ClauseBase(IToken prefix, StatementBase statement) {
			this.List.Add(prefix);
			_statement = statement;
			Empty = true;
		}

		protected bool Empty {
			get {
				return (this._empty);
			}
			set {
				this._empty = value;
			}
		}

		protected StatementBase Statement {
			get { return _statement; }
		}

		public bool IsEmpty() {
			return Empty;
		}

		protected virtual TokenList List {
			get {
				return (this._list);
			}
		}

		TokenList IToken.GetList() {
			return List;
		}

	}
}
