using System;

namespace ReflectionIT.Data.Sql
{
	/// <summary>
	/// Base Classes for all SQL clauses
	/// </summary>
	public class ValuesClause : ClauseBase {

		private ExpressionList _fields;
		private ExpressionList _values;

		internal ValuesClause(StatementBase statement) : base(new Keyword(" ("), statement) {
			_fields = new ExpressionList();
			_values = new ExpressionList();
			this.List.Add(_fields);
			this.List.Add(new Keyword(")\r\nvalues ("));
			this.List.Add(_values);
			this.List.Add(new Literal(")"));
		}

		public ValuesClause Add(string value) {
			return this.Add((Identifier)null, new Expression(value));
		}

		public ValuesClause Add(string columnName, IToken value) {
			return this.Add(new Identifier(columnName), value);
		}

		public ValuesClause Add(Identifier columnName, IToken value) {
			_fields.Add(columnName);
			_values.Add(value);

			return this;
		}
	}
}
