using System;
using System.Data;
using System.Data.OleDb;
using System.Text;

namespace ReflectionIT.Data.Sql
{
	public abstract class OleDbCommandBuilder : CommandBuilderBase {

		protected override IDbCommand CreateCommand() {
			return new OleDbCommand();
		}

		protected override void Append(IDbCommand command, StringBuilder sql, Constant constant) {
			sql.Append("?");
			OleDbParameter p = new OleDbParameter(constant.Name, constant.Value);
			if (constant.Value is DateTime) {
				p.OleDbType = OleDbType.Date;
			} else {
				if (constant.Value is int) {
					p.OleDbType = OleDbType.Integer;
				} else {
					if (constant.Value is bool) {
						p.OleDbType = OleDbType.Boolean;
					} else {
						if (constant.Value is Double) {
							p.OleDbType = OleDbType.Double;
						} else {
							if (constant.Value is Decimal) {
								p.OleDbType = OleDbType.Decimal;
							}					
						}					
					}
				}
			}
			command.Parameters.Add(p);
		}

	}
}
