using System;
using System.Data;
using System.Data.OracleClient;
using System.Text;

namespace ReflectionIT.Data.Sql
{
	public class OracleCommandBuilder : CommandBuilderBase {

		public static readonly OracleCommandBuilder Value = new OracleCommandBuilder();

		/// <summary>
		/// Singleton
		/// </summary>
		private OracleCommandBuilder() {
		}

		protected override IDbCommand CreateCommand() {
			return new OracleCommand();
		}

		protected override void Append(IDbCommand command, StringBuilder sql, Constant constant) {
			string name = constant.Name;
			if (name == null || name.Length == 0) {
				name = "par" + command.Parameters.Count.ToString();
			} 
			sql.Append(":" + name);
			command.Parameters.Add(new OracleParameter(name, constant.Value));
		}

		protected override void Append(IDbCommand command, StringBuilder sql, Keyword keyword) {
			string s = keyword.ToString().ToUpper();
			if (s.Trim() != "AS") {
				sql.Append(s);
			} else {
				sql.Append(" ");
			}
		}
	}
}
