using System;
using System.Data;
using System.Data.SqlClient;
using System.Text;

namespace ReflectionIT.Data.Sql
{
	public class SqlCommandBuilder : CommandBuilderBase {

		public static readonly SqlCommandBuilder Value = new SqlCommandBuilder();

		/// <summary>
		/// Singleton
		/// </summary>
		private SqlCommandBuilder() {
		}

		protected override IDbCommand CreateCommand() {
			return new SqlCommand();
		}

		protected override void Append(IDbCommand command, StringBuilder sql, Constant constant) {
			string name = "@" + constant.Name;
			if (name.Length == 1) {
				name = "@par" + command.Parameters.Count.ToString();
			} 
			sql.Append(name);
			command.Parameters.Add(new SqlParameter(name, constant.Value));
		}

		protected override void Append(IDbCommand command, StringBuilder sql, Identifier identifier) {
			sql.Append("[");
			sql.Append(identifier.ToString());
			sql.Append("]");
		}
	}
}
