using System;
using System.Data;

namespace ReflectionIT.Data.Sql
{
	public abstract class DmlStatementBase : StatementBase {

		private DmlClause _dml;

		/// <summary>
		/// Constructor
		/// </summary>
		/// <param name="commandBuilder"></param>
		public DmlStatementBase(CommandBuilderBase commandBuilder) : base(commandBuilder) {
		}

		protected DmlClause Dml {
			get {
				return (this._dml);
			}
			set {
				_dml = value;
			}
		}

		/// <summary>
		/// Get or set the TableName
		/// </summary>
		public virtual string TableName {
			get {
				return (this.Dml.TableName);
			}
			set {
				this.Dml.TableName = value;
			}
		}

	}
}
