using System;

namespace ReflectionIT.Data.Sql
{
	/// <summary>
	/// The InsertStatementBase is used as a base class for InsertStatement classes.
	/// </summary>
	/// <remarks>
	/// Copyright  2003 Reflection IT
	/// 
	/// This software is provided 'as-is', without any express or implied warranty.
	/// In no event will the authors be held liable for any damages arising from the
	/// use of this software.
	/// 
	/// Permission is granted to anyone to use this software for any purpose,
	/// including commercial applications, subject to the following restrictions:
	/// 
	/// 1. The origin of this software must not be misrepresented; you must not claim
	/// that you wrote the original software. 
	/// 
	/// 2. No substantial portion of the source code of this library may be redistributed
	/// without the express written permission of the copyright holders, where
	/// "substantial" is defined as enough code to be recognizably from this library. 
	/// 
	/// </remarks>
	public abstract class InsertStatementBase : DmlStatementBase {

		private ValuesClause _values;

		public InsertStatementBase(CommandBuilderBase commandBuilder) : base(commandBuilder) {
			Dml = new DmlClause(new Keyword("insert into "), this);
			_values = new ValuesClause(this);
		}

		public ValuesClause Values {
			get {
				return (this._values);
			}
		}

		protected override TokenList GetList() {
			TokenList list = new TokenList();
			list.Add(this.Dml);
			list.Add(this.Values);
			return list;
		}

	}
}
