using System;

namespace ReflectionIT.Data.Sql
{
	public class ExpressionList : IToken {

		private TokenList _list = new TokenList();

		public ExpressionList() {
		}

		public ExpressionList(IToken expression) {
			this._list.Add(expression);
		}

		public ExpressionList(IToken[] expressions) {
			foreach (IToken expression in expressions) {
				this._list.Add(expression);
			}
		}

		protected TokenList List {
			get {
				return (this._list);
			}
		}

		public ExpressionList Add(IToken expression) {
			if (this._list.Count > 0) {
				this._list.Add(new Literal(", "));
			}
			this._list.Add(expression);
			return this;
		}

		TokenList IToken.GetList() {
			return _list;
		}

	}
}
