using System;

namespace ReflectionIT.Data.Sql
{
	public class Expression : IToken {

		private TokenList _list = new TokenList();

		public Expression(IToken word) {
			this._list.Add(word);
		}

		public Expression(string text) {
			this._list.Add(new Literal(text));
		}

		protected TokenList List {
			get {
				return (this._list);
			}
		}

		public Expression Add(IToken word) {
			this._list.Add(word);
			return this;
		}

		/// <summary>
		/// Add a literal text
		/// </summary>
		/// <param name="text"></param>
		/// <returns></returns>
		public Expression Add(string text) {
			this._list.Add(new Literal(text));
			return this;
		}

		TokenList IToken.GetList() {
			return _list;
		}

	}
}
