using System;

namespace ReflectionIT.Data.Sql
{
	public class Identifier : Literal, IToken {

		private TokenList _list;

		public Identifier(string text) : base(text) {
			string[] s = text.Split(new char[] {'.'});
			if (s.GetLength(0) > 1) {
				_list = new TokenList();
				foreach (string w in s) {
					_list.Add(new Identifier(w));
					_list.Add(new Keyword("."));
				}
				_list.RemoveAt(_list.Count -1);
			}
		}

		protected TokenList List {
			get {
				return (this._list);
			}
		}

		TokenList IToken.GetList() {
			return _list;
		}

	}
}
